<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\user_framework\browsable_query_loader.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<!DOCTYPE html>
<head>
	<title></title>
	
	<style type="text/css">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=styles/default.css -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		div.filter
		{
			background: #fff9b0;
			margin-left: 25px;
			margin-top: 2px;
			margin-bottom: 2px;
			padding: 2px;
			border: 1px solid black;
		}
		
		.labelNode
		{
			cursor: pointer;
			text-decoration: underline;
		}
		
		.dijitInline 
		{
			/*  To inline block elements.
				Similar to InlineBox below, but this has fewer side-effects in Moz.
				Also, apparently works on a DIV as well as a FIELDSET.
			*/
			display:-moz-inline-box;		/* FF2 */
			display:inline-block;			/* webkit and FF3 */
			#zoom: 1; /* set hasLayout:true to mimic inline-block */
			#display:inline; /* don't use .dj_ie since that increases the priority */
			border:0;
			padding:0;
			vertical-align:middle;
		}
		
		/* Tree */
		.dijitTreeExpando, .dijitTreeExpand 
		{
			float:left;
			display:inline;
		}
		
		.dijitTreeExpando 
		{
			clear:both;
		}
		
		.dijitTreeContent 
		{
		    cursor: default;
		    /* can't make inline - multiline bugs */
		}
		
		.dijitExpandoText 
		{
			display: none;
		}
		
		.dijit_a11y .dijitExpandoText 
		{
			float: left;
			display: inline;
			padding-left: 10px;
			padding-right: 10px;
			font-family: monospace;
			border-style: solid;
			border-width: thin;
			cursor: pointer;
		}
		
		.dijitTreeNode 
		{
		    background-image : url('trapeze/ptimages/i.gif');
		    background-position : top left;
		    background-repeat : repeat-y;
		    margin-left: 19px;
		    zoom: 1;	/* What this is doing here? */
		}
		
		/* left vertical line (grid) for all nodes */		
		.dijitTreeIsLast 
		{
		    background: url('trapeze/ptimages/i_half.gif') no-repeat;
		}
		
		.dijitTreeIsRoot 
		{
		   margin-left: 0;
		   background-image: none;
		}
		
		.dijitTreeExpando 
		{
		    width: 18px;
		    height: 18px;
		}
		
		.dijitTreeContent 
		{
		    min-height: 18px;
		    min-width: 18px;
		    margin-left:18px;
		    padding-top:3px;
		    padding-left:1px;
		}		
		
		.dijitTreeExpand 
		{
		    width: 18px;
		    height: 18px;
		    background-repeat : no-repeat;
		}
		
		/* same style as IE selection */
		.dijitTreeNodeEmphasized 
		{
		    background-color: Highlight;
		    color: HighlightText;
		}
		
		/* don't use :focus due to opera and IE's lack of support on div's */
		.dijitTreeLabelFocused 
		{
			outline: 1px invert dotted;
			background:#dde7f2;
		}
		
		.dijitTreeExpandoOpened 
		{
			background-image: url('trapeze/ptimages/treeExpand_minus.gif');
		}
		
		.dijitTreeExpandoClosed 
		{
			background-image: url('trapeze/ptimages/treeExpand_plus.gif');
		}

		.dijitTreeExpandoLeaf 
		{
			background-image: url('trapeze/ptimages/treeExpand_leaf.gif');
		}
		
		.dijitTreeExpandoLoading 
		{
			background-image: url('trapeze/ptimages/spinningWait.gif');
		}
		
		.dijitTreeIcon 
		{
			width: 16px;
			height: 16px;
			padding-right: 4px;
		}
	</style>
	
	<script type="text/javascript" src="dwr/interface/LdapUserUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
	<script type="text/javascript" src="dwr/interface/BrowseUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	
	<script type="text/javascript">		
		dojo.require("dojo.data.ItemFileReadStore");
		dojo.require("dijit.tree.ForestStoreModel");
		dojo.require("dijit.Tree");
		dojo.require("dijit.Tooltip");
		dojo.require("dijit.TitlePane");
		dojo.require("dojo.fx");
		
		dojo.registerModulePath("custom", "../../customDojo");
		dojo.require("custom.BrowseCrTree");
	
		<change:wsletExpander>
			<!-- WSLET CODE=PTAdmin -->
			<!-- PARAM NAME=USER_PROFILE_VALUE -->
			<!-- PARAM NAME=user_saved_browsable_relations -->
			<!-- PARAM NAME=ENCODE -->
			<!-- PARAM NAME=JAVASCRIPT_IDENTIFIER value=savedBrowsableRelations -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		var browsableQuery = new Object();
		browsableQuery.name = <change:javaScriptEscape value="${browsableQuery.name}"/>;
		browsableQuery.adminDefined = ${browsableQuery.adminDefined};
		
		var asAdmin = <change:javaScriptEscape value ="${param.asAdmin}"/>;
		var cancelLoading = false;
		var currentRequestId = -1;
		
		var AttributeNames =
		{
			PROBLEM_NUMBER: "problem_number",
			PROBLEM_SYNOPSIS: "problem_synopsis",
			TASK_NUMBER: "task_number",
			TASK_SYNOPSIS: "task_synopsis",
			DISPLAY_NAME: "displayname",
			ATTACHMENT_NAME: "attachment_name",
			DOORS_OBJECT_PATH: "doors_object_path",
			CVTYPE: "cvtype",
			CVID: "cvid",
			CRSTATUS: "crstatus",
			STATUS: "status",
			FROM_DB_PATH: "from_db_path"
		};
		
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=toggleSection.js -->
			<!-- PARAM NAME=domUtilities.js -->
			<!-- PARAM NAME=DisplayModes.js -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		function selectAllOnClick()
		{
			var checkboxes = document.relationSelector.relations;
			var length = checkboxes.length;
			
			for (var i = 0; i < length; i++)
			{
				checkboxes[i].checked = true;
			}
			
			relationOnClick();
		}
		
		function clearAllOnClick(userAction)
		{
			var checkboxes = document.relationSelector.relations;
			var length = checkboxes.length;
			
			for (var i = 0; i < length; i++)
			{
				checkboxes[i].checked = false;
			}
			
			if (userAction)
			{
				relationOnClick();
			}
		}
		
		//Returns an array of relation names.
		function getSelectedRelations()
		{
			var relations = new Array();
			var checkboxes = document.relationSelector.relations;
			var length = checkboxes.length;
			
			for (var i = 0; i < length; i++)
			{
				if (checkboxes[i].checked)
				{
					relations[relations.length] = checkboxes[i].value;
				}
			}
			
			return relations;
		}
		
		function relationOnClick()
		{
			var relations = getSelectedRelations();
			
			LdapUserUtilsAjax.setStringPreference("${user.token}", 'user_saved_browsable_relations', relations.toString());
		}
		
		function isAttachmentObject(item)
		{
			if (item[AttributeNames.ATTACHMENT_NAME] != null 
				&& item[AttributeNames.ATTACHMENT_NAME] != undefined
				&& item[AttributeNames.ATTACHMENT_NAME].length > 0
				&& item[AttributeNames.ATTACHMENT_NAME] != "&nbsp;")
			{
				return true;
			}
			
			return false;
		}
	
		function isDoorsObject(item)
		{
			if (item[AttributeNames.DOORS_OBJECT_PATH] != null 
				&& item[AttributeNames.DOORS_OBJECT_PATH] != undefined
				&& item[AttributeNames.DOORS_OBJECT_PATH].length > 0)
			{
				return true;
			}
			
			return false;
		}
		
		function hasModifications()
		{
			if (parent.showView && parent.showView.workspace 
				&& parent.showView.workspace.hasModifications)
			{
				return parent.showView.workspace.hasModifications();
			}
			
			return false;
		}
		
		function showChangeRequest(treeNode)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
			
			var showUrl = '<change:urlCreator webResource="PTWEB"/>'
					+ '?role=' + escape('${user.role}')
					+ '&token=' + escape('${user.token}')
					+ '&ACTION_FLAG=frameset_form'
					+ '&TEMPLATE_FLAG=DialogProblemShow'
					+ '&SUPP_DISPLAY_MODE=' + DisplayModes.READ_ONLY
					+ '&problem_number=' + escape(treeNode[AttributeNames.PROBLEM_NUMBER]);
		
			parent.showView.location.href = showUrl;
		}
		
		function showTask(treeNode)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
			
			var showUrl = '<change:urlCreator webResource="PTWEB"/>'
					+ '?role=' + escape('${user.role}')
					+ '&token=' + escape('${user.token}')
					+ '&ACTION_FLAG=frameset_form'
					+ '&TEMPLATE_FLAG=DialogTaskShow'
					+ '&SUPP_DISPLAY_MODE=' + DisplayModes.READ_ONLY
					+ '&task_number=' + escape(treeNode[AttributeNames.TASK_NUMBER])//escape(treeNode.object[AttributeNames.TASK_NUMBER])
					+ '&from_db_path=' + encodeURIComponent(treeNode[AttributeNames.FROM_DB_PATH]);//encodeURIComponent(treeNode.object[AttributeNames.FROM_DB_PATH]);
					
			parent.showView.location.href = showUrl;
		}
		
		function showObject(treeNode)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			var showUrl = '<change:urlCreator webResource="PTWEB"/>'
					+ '?role=' + escape('${user.role}')
					+ '&token=' + escape('${user.token}')
					+ '&ACTION_FLAG=frameset_form'
					+ '&TEMPLATE_FLAG=DialogObjectShow'
					+ '&cvid=' + escape(treeNode[AttributeNames.CVID])
					+ '&from_db_path=' + encodeURIComponent(treeNode[AttributeNames.FROM_DB_PATH]);
								
			parent.showView.location.href = showUrl;
		}
		
		function showDoorsObject(treeNode)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			var showUrl = '<change:urlCreator webResource="PTWEB"/>'
					+ '?role=' + escape('${user.role}')
					+ '&token=' + escape('${user.token}')
					+ '&ACTION_FLAG=frameset_form'
					+ '&TEMPLATE_FLAG=RCDetailsView'
					+ '&cvid=' + escape(treeNode[AttributeNames.CVID])
					+ '&from_db_path=' + encodeURIComponent(treeNode[AttributeNames.FROM_DB_PATH]);
								
			parent.showView.location.href = showUrl;
		}
		
		function downloadAttachment(treeNode)
		{	
			var url = '<change:urlCreator webResource="PTWEB"/>' 
					+ '?ACTION_FLAG=object_show_form' 
					+ '&TEMPLATE_FLAG=DownloadAttachment' 
					+ '&RELATION_NAME=attachment' 
					+ '&cvid=' + escape(treeNode[AttributeNames.CVID]) 
					+ '&role=' + escape('${user.role}') 
					+ '&user=' + escape('${user.userName}')
					+ '&database=' + <change:javaScriptEscape value="${user.database}"/>
					+ '&from_db_path=' + encodeURIComponent(treeNode[AttributeNames.FROM_DB_PATH]);
						      			      
			var w = window.open(url,'related_obj','<change:wsletExpander><!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=FILE_DOWNLOAD_WINDOW_OPTIONS --><!-- /WSLET --></change:wsletExpander>');
			w.focus();
		}

		
		/*
		 * Helper function: Call this from dojo file when imported as dojo.require.
		 */
		function getMessage()
		{
			return '<change:resource key="browseNoResults"/>';
		}
		
		
		/*
		 * Helper function: this will be invoked by dojo.
		 */
		function lookupRelationInformation(nodeRef, item, nodeWidget)
		{
			var relations = getSelectedRelations();				
			
			// Laod the relation information by an Ajax call.
			BrowseUtilsAjax.lookupRelationInformation("${user.token}", item, relations, function(results)
			{
				nodeRef._removeAndAddClass(nodeWidget.expandoNode, ["dijitTreeExpando", "dijitTreeExpandoOpened"]);						
				nodeRef.updateTree(nodeWidget, relations, results);
			});
		}
		
		function runBrowsableQuery()
		{
			if (cancelLoading)
			{
				return;
			}
			
			BrowseUtilsAjax.getReportRequest("${user.token}", browsableQuery.name, longIdCallBack);
			
			function longIdCallBack(longRequestId)
			{
				currentRequestId = longRequestId;
				
				BrowseUtilsAjax.runBrowsableQuery("${user.token}", longRequestId, browsableQuery.adminDefined, asAdmin, browsableQuery.name, callback);
				
				function callback(results)
				{
					createTree(results);
					
					currentRequestId = -1;
				};
			};
		}
		
		
		/*
		 * Create a tree from the data got.
		 */
		function createTree(results)
		{
			var length = results.length;
			
			dojo.style(dojo.byId("buildReport"), "display", "none");
			
			if (length == 0)
			{
				dojo.style(dojo.byId("noResults"), "display", "");
				return;
			}
			
			var rootName = <change:javaScriptEscape value="${browsableQuery.name}"/>;
			
			var crStore = new dojo.data.ItemFileReadStore(
			{
				data: {
					label: "__title__",
					identifier: "problem_number",
					items: results
				}
			});
		    var treeModel = new dijit.tree.ForestStoreModel({
		        store: crStore,
		        query: {
		            "type": "problem"
		        },
				rootId: "root",
				rootLabel: rootName,
		        childrenAttrs: ["children"]
		    });
		    new custom.BrowseCrTree({
				model: treeModel,
				labelAttr: "name",
				showRoot: "false",
				label: rootName
		    }, "divTree");
		}
		
		function showRelationQuery(anchorId, filterDivId)
		{
			var anchor = document.getElementById(anchorId);
			var filterDiv = document.getElementById(filterDivId);
			
			if (filterDiv.style.display == "none")
			{
				anchor.innerHTML = "<change:resource key="hideFilter"/>";
				dojo.fx.wipeIn(
				{
					node: filterDiv,
					duration: 250
				}).play();
			}
			else
			{
				anchor.innerHTML = "<change:resource key="showFilter"/>";
				dojo.fx.wipeOut(
				{
					node: filterDiv,
					duration: 250
				}).play();
			}
		}
		
		function pageLoad()
		{
			//comma is used by default for Array.toString();
			var relations = savedBrowsableRelations.split(",");
			
			if (relations.length > 0 && savedBrowsableRelations.length > 0)
			{
				clearAllOnClick(false);
		
				var checkboxes = document.relationSelector.relations;
				var length = checkboxes.length;
					
				for (var i = 0; i < length; i++)
				{
					for (var x = 0; x < relations.length; x++)
					{
						if (relations[x] == checkboxes[i].value)
						{
							checkboxes[i].checked = true;	
						}
					}
				}
			}
			
			runBrowsableQuery();
		}
		
		function pageUnload()
		{
			cancelLoading = true;
			
			if (currentRequestId != -1)
			{		
				window.document.cancel_form.long_request_id.value = currentRequestId;
				window.document.cancel_form.submit();
			}
		}
		
		dojo.addOnLoad(pageLoad);
		dojo.addOnUnload(pageUnload);
	</script>
</head>
<body>

<div style="padding: 3px; width: 95%;">
<form name="relationSelector">
	<table class="section" width="100%" cellpadding="0" cellspacing="0">
		<thead ID="section-0" onclick="toggleSection(this);">
			<tr>
				<th>
					<change:resource key="selectBrowseRelationships"/>
				</th>
				<th style="text-align: right;">
					<img alt="<change:resource key='altTextDown'/>" src="<change:urlCreator webResource="PTIMAGES"/>down_chevron.gif" border="0" STYLE="margin: 0px 7px 0px 1px;"/>
				</th>
			</tr>
			<tbody style="display: none;">
				<tr>
					<td>
						&nbsp;<a href="javascript:selectAllOnClick();" title="<change:resource key='selectAllBrowse'/>"><change:resource key="lbl00599"/></a>
						|
						<a href="javascript:clearAllOnClick(true);" title="<change:resource key='clearAllBrowse'/>"><change:resource key="lbl00717"/></a>
					</td>
				</tr>
				
				<c:forEach var="attributeDefinition" items="${relationAttributes}">
					<tr>
						<td>
							<c:choose>
								<c:when test="${not empty attributeDefinition.description}">
									<c:set var="disc" value="${attributeDefinition.description}"/>
								</c:when>
								<c:otherwise>
									<c:set var="disc">
										<change:resource key="noAttributeDesc"/>
									</c:set>
								</c:otherwise>
							</c:choose>
								
							<input type="checkbox" id="${attributeDefinition.name}" name="relations" value="${attributeDefinition.name}" onclick="javascript: relationOnClick();" <c:if test="${attributeDefinition.enabledInBrowseQueries}">CHECKED</c:if>>
							<img id="${attributeDefinition.name}_img" src="<change:urlCreator webResource="RELATIONSHIPIMAGES"/>${attributeDefinition.iconName}"/>
							<label class="tooltip" id="${attributeDefinition.name}_tt" for="${attributeDefinition.name}" title="${disc}"><c:out value="${attributeDefinition.alias}"/></label>
							
							<%-- dijit.ToolTip is not showing up at proper position. Need to fix This --%>
							<%--span dojoType="dijit.Tooltip" connectId="${attributeDefinition.name}_tt" duration="100" showDelay="0">
								<c:choose>
									<c:when test="${not empty attributeDefinition.description}">
										<c:out value="${attributeDefinition.description}"/>
									</c:when>
									<c:otherwise>
										<change:resource key="noAttributeDesc"/>
									</c:otherwise>
								</c:choose>
							</span--%>
							
							<c:if test="${relationFilters[attributeDefinition.name] != null}">
								<a id="${attributeDefinition.name}_ahref" href="javascript:showRelationQuery('${attributeDefinition.name}_ahref', '${attributeDefinition.name}_filter')" style="font-size: x-small;" title="<change:resource key="filterToolTip"/>">
									<change:resource key="showFilter"/>
								</a>
								
								<div id="${attributeDefinition.name}_filter" class="filter" style="display: none;">
									<b><change:resource key="filterLabel"/></b>
									${relationFilters[attributeDefinition.name]}
								</div>
							</c:if>
						</td>
					</tr>
				</c:forEach>
			</tbody>
		<thead>
	</table>
	

	<div id="browsableQuery" style="padding-left: 5px">
		<div id="buildReport">
			<img src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif"/> <change:resource key='lbl00110'/>
		</div>
		
		<div id="noResults" style="display: none">
			&nbsp;&nbsp;<change:resource key='browseNoResults'/>
		</div>
		
		<div id="divTree">
			<!-- Populate tree nodes on-the-fly -->
		</div>
		
		</div>
	</div>
</form>
</div>

<form name="cancel_form" action="<change:urlCreator webResource='PTACTION'/>" class="hiddenForm" method="POST" TARGET="hiddenFrame">
	<input name="token" type="hidden" value="${user.token}">
	<input name="ACTION_FLAG" type="hidden" value="pt_cancel">
	<input name="long_request_id" type="hidden" value="NO_ACTION">
</form>

</body>
</html>
